
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_trophiesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_trophies = await db.user_trophies.create(
            {
                id: data.id || undefined,
        
        award_status: data.award_status
        ||
        null
            ,
            
        award_reason: data.award_reason
        ||
        null
            ,
            
        awarded_at: data.awarded_at
        ||
        null
            ,
            
        is_visible_on_profile: data.is_visible_on_profile
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_trophies.setUser( data.user || null, {
            transaction,
        });
        
        await user_trophies.setTrophy( data.trophy || null, {
            transaction,
        });
        

        

        

        return user_trophies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_trophiesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                award_status: item.award_status
            ||
            null
            ,
            
                award_reason: item.award_reason
            ||
            null
            ,
            
                awarded_at: item.awarded_at
            ||
            null
            ,
            
                is_visible_on_profile: item.is_visible_on_profile
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_trophies = await db.user_trophies.bulkCreate(user_trophiesData, { transaction });

        // For each item created, replace relation files
        

        return user_trophies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const user_trophies = await db.user_trophies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.award_status !== undefined) updatePayload.award_status = data.award_status;
        
        
        if (data.award_reason !== undefined) updatePayload.award_reason = data.award_reason;
        
        
        if (data.awarded_at !== undefined) updatePayload.awarded_at = data.awarded_at;
        
        
        if (data.is_visible_on_profile !== undefined) updatePayload.is_visible_on_profile = data.is_visible_on_profile;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_trophies.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_trophies.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.trophy !== undefined) {
            await user_trophies.setTrophy(
              
              data.trophy,
              
              { transaction }
            );
        }
        

        
        

        

        return user_trophies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_trophies = await db.user_trophies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_trophies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_trophies) {
                await record.destroy({transaction});
            }
        });


        return user_trophies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_trophies = await db.user_trophies.findByPk(id, options);

        await user_trophies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_trophies.destroy({
            transaction
        });

        return user_trophies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_trophies = await db.user_trophies.findOne(
            { where },
            { transaction },
        );

        if (!user_trophies) {
            return user_trophies;
        }

        const output = user_trophies.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_trophies.getUser({
            transaction
        });
        
        
        output.trophy = await user_trophies.getTrophy({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.trophies,
        as: 'trophy',
        
        where: filter.trophy ? {
          [Op.or]: [
            { id: { [Op.in]: filter.trophy.split('|').map(term => Utils.uuid(term)) } },
            {
              trophy_name: {
                [Op.or]: filter.trophy.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.award_reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_trophies',
                        'award_reason',
                        filter.award_reason,
                    ),
                };
            }
            

            
            

            
            if (filter.awarded_atRange) {
                const [start, end] = filter.awarded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    awarded_at: {
                    ...where.awarded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    awarded_at: {
                    ...where.awarded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.award_status) {
                where = {
                    ...where,
                award_status: filter.award_status,
            };
            }
            
            if (filter.is_visible_on_profile) {
                where = {
                    ...where,
                is_visible_on_profile: filter.is_visible_on_profile,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_trophies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_trophies',
                        'award_status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_trophies.findAll({
            attributes: [ 'id', 'award_status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['award_status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.award_status,
        }));
    }

    
};

